package xyz.tbvns.mcreflect.client.keybindings;

import net.fabricmc.fabric.api.client.event.lifecycle.v1.ClientTickEvents;
import net.fabricmc.fabric.api.client.keybinding.v1.KeyBindingHelper;
import net.minecraft.client.MinecraftClient;
import net.minecraft.client.option.KeyBinding;
import net.minecraft.client.util.InputUtil;
import net.minecraft.text.Text;
import org.lwjgl.glfw.GLFW;

public interface ReflectionKeybinding {
    default String getTranslationKey() {
        return "mcreflect.keybinding.default";
    }

    default InputUtil.Type getType() {
        return InputUtil.Type.KEYSYM;
    }

    default int getKey() {
        return GLFW.GLFW_KEY_P;
    }

    default String getCategoryTranslationKey() {
        return "mcreflect.keybinding.category.default";
    }

    default Runnable getOnPress() {
        return () -> {
            MinecraftClient.getInstance().player.sendMessage(Text.of("The key was pressed !"));
        };
    }

    default void register() {
        KeyBinding keyBinding = KeyBindingHelper.registerKeyBinding(new KeyBinding(
                getTranslationKey(), // The translation key of the keybinding's name
                getType(), // The type of the keybinding, KEYSYM for keyboard, MOUSE for mouse.
                getKey(), // The keycode of the key
                getCategoryTranslationKey() // The translation key of the keybinding's category.
        ));
        ClientTickEvents.END_CLIENT_TICK.register(client -> {
            while (keyBinding.wasPressed()) {
                getOnPress().run();
            }
        });

        ReflectKeybindingsManager.registeredKeybindings.add(keyBinding);
    }
}
